'From Squeak3.8gamma of ''24 November 2004'' [latest update: #6527] on 7 December 2004 at 11:02:49 pm'!
MenuItemMorph subclass: #UpdatingMenuItemMorph
	instanceVariableNames: 'wordingProvider wordingSelector enablementSelector wordingArgument stepTimeGuess'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Menus'!

!UpdatingMenuItemMorph commentStamp: 'spfa 11/30/2004 20:42' prior: 0!
A menu item whose textual label and whose enablement are updatable.  The wordingProvider provides the current wording, upon being being sent the wordingSelector.

The item can also dynamically update whether or not it should be enabled; to do this, give it an enablementSelector, which is also sent to the wordingProvider..

spfa add-on:

the stepTime is dynamically computed so that updates are as fast as possible with respect to the involved overhead!


!UpdatingMenuItemMorph methodsFor: 'stepping and presenter' stamp: 'spfa 11/30/2004 20:44'!
step
	super step.
	stepTimeGuess _ ([self updateContents] timeToRun * 100) min: 100.! !

!UpdatingMenuItemMorph methodsFor: 'testing' stamp: 'spfa 11/30/2004 20:45'!
stepTime

	^ stepTimeGuess ifNil: [500]! !

